<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/unwinding-0.1.4/src/personality.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>personality.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../unwinding/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
</pre><pre class="rust"><code><span class="comment">// References:</span>
<span class="comment">// https://github.com/rust-lang/rust/blob/c4be230b4a30eb74e3a3908455731ebc2f731d3d/library/panic_unwind/src/gcc.rs</span>
<span class="comment">// https://github.com/rust-lang/rust/blob/c4be230b4a30eb74e3a3908455731ebc2f731d3d/library/panic_unwind/src/dwarf/eh.rs</span>
<span class="comment">// https://docs.rs/gimli/0.25.0/src/gimli/read/cfi.rs.html</span>

<span class="kw">use</span> <span class="ident">core::mem</span>;
<span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">constants</span>, <span class="ident">NativeEndian</span>};
<span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">EndianSlice</span>, <span class="ident">Error</span>, <span class="ident">Pointer</span>, <span class="ident">Reader</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::abi</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::arch</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::util</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">enum</span> <span class="ident">EHAction</span> {
    <span class="prelude-val">None</span>,
    <span class="ident">Cleanup</span>(<span class="ident">usize</span>),
    <span class="ident">Catch</span>(<span class="ident">usize</span>),
}

<span class="kw">fn</span> <span class="ident">parse_pointer_encoding</span>(<span class="ident">input</span>: <span class="kw-2">&amp;mut</span> <span class="ident">StaticSlice</span>) -&gt; <span class="ident">gimli::Result</span><span class="op">&lt;</span><span class="ident">constants::DwEhPe</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">eh_pe</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">read_u8</span>()<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">eh_pe</span> <span class="op">=</span> <span class="ident">constants::DwEhPe</span>(<span class="ident">eh_pe</span>);

    <span class="kw">if</span> <span class="ident">eh_pe</span>.<span class="ident">is_valid_encoding</span>() {
        <span class="prelude-val">Ok</span>(<span class="ident">eh_pe</span>)
    } <span class="kw">else</span> {
        <span class="prelude-val">Err</span>(<span class="ident">gimli::Error::UnknownPointerEncoding</span>)
    }
}

<span class="kw">fn</span> <span class="ident">parse_encoded_pointer</span>(
    <span class="ident">encoding</span>: <span class="ident">constants::DwEhPe</span>,
    <span class="ident">unwind_ctx</span>: <span class="kw-2">&amp;</span><span class="ident">UnwindContext</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>,
    <span class="ident">input</span>: <span class="kw-2">&amp;mut</span> <span class="ident">StaticSlice</span>,
) -&gt; <span class="ident">gimli::Result</span><span class="op">&lt;</span><span class="ident">Pointer</span><span class="op">&gt;</span> {
    <span class="kw">if</span> <span class="ident">encoding</span> <span class="op">==</span> <span class="ident">constants::DW_EH_PE_omit</span> {
        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::CannotParseOmitPointerEncoding</span>);
    }

    <span class="kw">let</span> <span class="ident">base</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">encoding</span>.<span class="ident">application</span>() {
        <span class="ident">constants::DW_EH_PE_absptr</span> =&gt; <span class="number">0</span>,
        <span class="ident">constants::DW_EH_PE_pcrel</span> =&gt; <span class="ident">input</span>.<span class="ident">slice</span>().<span class="ident">as_ptr</span>() <span class="kw">as</span> <span class="ident">u64</span>,
        <span class="ident">constants::DW_EH_PE_textrel</span> =&gt; <span class="ident">_Unwind_GetTextRelBase</span>(<span class="ident">unwind_ctx</span>) <span class="kw">as</span> <span class="ident">u64</span>,
        <span class="ident">constants::DW_EH_PE_datarel</span> =&gt; <span class="ident">_Unwind_GetDataRelBase</span>(<span class="ident">unwind_ctx</span>) <span class="kw">as</span> <span class="ident">u64</span>,
        <span class="ident">constants::DW_EH_PE_funcrel</span> =&gt; <span class="ident">_Unwind_GetRegionStart</span>(<span class="ident">unwind_ctx</span>) <span class="kw">as</span> <span class="ident">u64</span>,
        <span class="ident">constants::DW_EH_PE_aligned</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::UnsupportedPointerEncoding</span>),
        <span class="kw">_</span> =&gt; <span class="macro">unreachable!</span>(),
    };

    <span class="kw">let</span> <span class="ident">offset</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">encoding</span>.<span class="ident">format</span>() {
        <span class="ident">constants::DW_EH_PE_absptr</span> =&gt; <span class="ident">input</span>.<span class="ident">read_address</span>(<span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>() <span class="kw">as</span> <span class="kw">_</span>),
        <span class="ident">constants::DW_EH_PE_uleb128</span> =&gt; <span class="ident">input</span>.<span class="ident">read_uleb128</span>(),
        <span class="ident">constants::DW_EH_PE_udata2</span> =&gt; <span class="ident">input</span>.<span class="ident">read_u16</span>().<span class="ident">map</span>(<span class="ident">u64::from</span>),
        <span class="ident">constants::DW_EH_PE_udata4</span> =&gt; <span class="ident">input</span>.<span class="ident">read_u32</span>().<span class="ident">map</span>(<span class="ident">u64::from</span>),
        <span class="ident">constants::DW_EH_PE_udata8</span> =&gt; <span class="ident">input</span>.<span class="ident">read_u64</span>(),
        <span class="ident">constants::DW_EH_PE_sleb128</span> =&gt; <span class="ident">input</span>.<span class="ident">read_sleb128</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">a</span><span class="op">|</span> <span class="ident">a</span> <span class="kw">as</span> <span class="ident">u64</span>),
        <span class="ident">constants::DW_EH_PE_sdata2</span> =&gt; <span class="ident">input</span>.<span class="ident">read_i16</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">a</span><span class="op">|</span> <span class="ident">a</span> <span class="kw">as</span> <span class="ident">u64</span>),
        <span class="ident">constants::DW_EH_PE_sdata4</span> =&gt; <span class="ident">input</span>.<span class="ident">read_i32</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">a</span><span class="op">|</span> <span class="ident">a</span> <span class="kw">as</span> <span class="ident">u64</span>),
        <span class="ident">constants::DW_EH_PE_sdata8</span> =&gt; <span class="ident">input</span>.<span class="ident">read_i64</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">a</span><span class="op">|</span> <span class="ident">a</span> <span class="kw">as</span> <span class="ident">u64</span>),
        <span class="kw">_</span> =&gt; <span class="macro">unreachable!</span>(),
    }<span class="question-mark">?</span>;

    <span class="kw">let</span> <span class="ident">address</span> <span class="op">=</span> <span class="ident">base</span>.<span class="ident">wrapping_add</span>(<span class="ident">offset</span>);
    <span class="prelude-val">Ok</span>(<span class="kw">if</span> <span class="ident">encoding</span>.<span class="ident">is_indirect</span>() {
        <span class="ident">Pointer::Indirect</span>(<span class="ident">address</span>)
    } <span class="kw">else</span> {
        <span class="ident">Pointer::Direct</span>(<span class="ident">address</span>)
    })
}

<span class="kw">fn</span> <span class="ident">find_eh_action</span>(
    <span class="ident">reader</span>: <span class="kw-2">&amp;mut</span> <span class="ident">StaticSlice</span>,
    <span class="ident">unwind_ctx</span>: <span class="kw-2">&amp;</span><span class="ident">UnwindContext</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>,
) -&gt; <span class="ident">gimli::Result</span><span class="op">&lt;</span><span class="ident">EHAction</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">func_start</span> <span class="op">=</span> <span class="ident">_Unwind_GetRegionStart</span>(<span class="ident">unwind_ctx</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ip_before_instr</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="ident">ip</span> <span class="op">=</span> <span class="ident">_Unwind_GetIPInfo</span>(<span class="ident">unwind_ctx</span>, <span class="kw-2">&amp;mut</span> <span class="ident">ip_before_instr</span>);
    <span class="kw">let</span> <span class="ident">ip</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">ip_before_instr</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> { <span class="ident">ip</span> } <span class="kw">else</span> { <span class="ident">ip</span> <span class="op">-</span> <span class="number">1</span> };

    <span class="kw">let</span> <span class="ident">start_encoding</span> <span class="op">=</span> <span class="ident">parse_pointer_encoding</span>(<span class="ident">reader</span>)<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">lpad_base</span> <span class="op">=</span> <span class="kw">if</span> <span class="op">!</span><span class="ident">start_encoding</span>.<span class="ident">is_absent</span>() {
        <span class="kw">unsafe</span> { <span class="ident">deref_pointer</span>(<span class="ident">parse_encoded_pointer</span>(<span class="ident">start_encoding</span>, <span class="ident">unwind_ctx</span>, <span class="ident">reader</span>)<span class="question-mark">?</span>) }
    } <span class="kw">else</span> {
        <span class="ident">func_start</span>
    };

    <span class="kw">let</span> <span class="ident">ttype_encoding</span> <span class="op">=</span> <span class="ident">parse_pointer_encoding</span>(<span class="ident">reader</span>)<span class="question-mark">?</span>;
    <span class="kw">if</span> <span class="op">!</span><span class="ident">ttype_encoding</span>.<span class="ident">is_absent</span>() {
        <span class="ident">reader</span>.<span class="ident">read_uleb128</span>()<span class="question-mark">?</span>;
    }

    <span class="kw">let</span> <span class="ident">call_site_encoding</span> <span class="op">=</span> <span class="ident">parse_pointer_encoding</span>(<span class="ident">reader</span>)<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">call_site_table_length</span> <span class="op">=</span> <span class="ident">reader</span>.<span class="ident">read_uleb128</span>()<span class="question-mark">?</span>;
    <span class="ident">reader</span>.<span class="ident">truncate</span>(<span class="ident">call_site_table_length</span> <span class="kw">as</span> <span class="kw">_</span>)<span class="question-mark">?</span>;

    <span class="kw">while</span> <span class="op">!</span><span class="ident">reader</span>.<span class="ident">is_empty</span>() {
        <span class="kw">let</span> <span class="ident">cs_start</span> <span class="op">=</span> <span class="kw">unsafe</span> {
            <span class="ident">deref_pointer</span>(<span class="ident">parse_encoded_pointer</span>(
                <span class="ident">call_site_encoding</span>,
                <span class="ident">unwind_ctx</span>,
                <span class="ident">reader</span>,
            )<span class="question-mark">?</span>)
        };
        <span class="kw">let</span> <span class="ident">cs_len</span> <span class="op">=</span> <span class="kw">unsafe</span> {
            <span class="ident">deref_pointer</span>(<span class="ident">parse_encoded_pointer</span>(
                <span class="ident">call_site_encoding</span>,
                <span class="ident">unwind_ctx</span>,
                <span class="ident">reader</span>,
            )<span class="question-mark">?</span>)
        };
        <span class="kw">let</span> <span class="ident">cs_lpad</span> <span class="op">=</span> <span class="kw">unsafe</span> {
            <span class="ident">deref_pointer</span>(<span class="ident">parse_encoded_pointer</span>(
                <span class="ident">call_site_encoding</span>,
                <span class="ident">unwind_ctx</span>,
                <span class="ident">reader</span>,
            )<span class="question-mark">?</span>)
        };
        <span class="kw">let</span> <span class="ident">cs_action</span> <span class="op">=</span> <span class="ident">reader</span>.<span class="ident">read_uleb128</span>()<span class="question-mark">?</span>;
        <span class="kw">if</span> <span class="ident">ip</span> <span class="op">&lt;</span> <span class="ident">func_start</span> <span class="op">+</span> <span class="ident">cs_start</span> {
            <span class="kw">break</span>;
        }
        <span class="kw">if</span> <span class="ident">ip</span> <span class="op">&lt;</span> <span class="ident">func_start</span> <span class="op">+</span> <span class="ident">cs_start</span> <span class="op">+</span> <span class="ident">cs_len</span> {
            <span class="kw">if</span> <span class="ident">cs_lpad</span> <span class="op">==</span> <span class="number">0</span> {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">EHAction::None</span>);
            } <span class="kw">else</span> {
                <span class="kw">let</span> <span class="ident">lpad</span> <span class="op">=</span> <span class="ident">lpad_base</span> <span class="op">+</span> <span class="ident">cs_lpad</span>;
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="kw">match</span> <span class="ident">cs_action</span> {
                    <span class="number">0</span> =&gt; <span class="ident">EHAction::Cleanup</span>(<span class="ident">lpad</span>),
                    <span class="kw">_</span> =&gt; <span class="ident">EHAction::Catch</span>(<span class="ident">lpad</span>),
                });
            }
        }
    }
    <span class="prelude-val">Ok</span>(<span class="ident">EHAction::None</span>)
}

<span class="attribute">#[<span class="ident">lang</span> <span class="op">=</span> <span class="string">&quot;eh_personality&quot;</span>]</span>
<span class="kw">fn</span> <span class="ident">rust_eh_personality</span>(
    <span class="ident">version</span>: <span class="ident">c_int</span>,
    <span class="ident">actions</span>: <span class="ident">UnwindAction</span>,
    <span class="ident">_exception_class</span>: <span class="ident">u64</span>,
    <span class="ident">exception</span>: <span class="kw-2">&amp;mut</span> <span class="ident">UnwindException</span>,
    <span class="ident">unwind_ctx</span>: <span class="kw-2">&amp;mut</span> <span class="ident">UnwindContext</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>,
) -&gt; <span class="ident">UnwindReasonCode</span> {
    <span class="kw">if</span> <span class="ident">version</span> <span class="op">!</span><span class="op">=</span> <span class="number">1</span> {
        <span class="kw">return</span> <span class="ident">UnwindReasonCode::FATAL_PHASE1_ERROR</span>;
    }

    <span class="kw">let</span> <span class="ident">lsda</span> <span class="op">=</span> <span class="ident">_Unwind_GetLanguageSpecificData</span>(<span class="ident">unwind_ctx</span>);
    <span class="kw">if</span> <span class="ident">lsda</span>.<span class="ident">is_null</span>() {
        <span class="kw">return</span> <span class="ident">UnwindReasonCode::CONTINUE_UNWIND</span>;
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">lsda</span> <span class="op">=</span> <span class="ident">EndianSlice::new</span>(<span class="kw">unsafe</span> { <span class="ident">get_unlimited_slice</span>(<span class="ident">lsda</span> <span class="kw">as</span> <span class="kw">_</span>) }, <span class="ident">NativeEndian</span>);
    <span class="kw">let</span> <span class="ident">eh_action</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">find_eh_action</span>(<span class="kw-2">&amp;mut</span> <span class="ident">lsda</span>, <span class="ident">unwind_ctx</span>) {
        <span class="prelude-val">Ok</span>(<span class="ident">v</span>) =&gt; <span class="ident">v</span>,
        <span class="prelude-val">Err</span>(<span class="kw">_</span>) =&gt; <span class="kw">return</span> <span class="ident">UnwindReasonCode::FATAL_PHASE1_ERROR</span>,
    };

    <span class="kw">if</span> <span class="ident">actions</span>.<span class="ident">contains</span>(<span class="ident">UnwindAction::SEARCH_PHASE</span>) {
        <span class="kw">match</span> <span class="ident">eh_action</span> {
            <span class="ident">EHAction::None</span> <span class="op">|</span> <span class="ident">EHAction::Cleanup</span>(<span class="kw">_</span>) =&gt; <span class="ident">UnwindReasonCode::CONTINUE_UNWIND</span>,
            <span class="ident">EHAction::Catch</span>(<span class="kw">_</span>) =&gt; <span class="ident">UnwindReasonCode::HANDLER_FOUND</span>,
        }
    } <span class="kw">else</span> {
        <span class="kw">match</span> <span class="ident">eh_action</span> {
            <span class="ident">EHAction::None</span> =&gt; <span class="ident">UnwindReasonCode::CONTINUE_UNWIND</span>,
            <span class="ident">EHAction::Cleanup</span>(<span class="ident">lpad</span>) <span class="op">|</span> <span class="ident">EHAction::Catch</span>(<span class="ident">lpad</span>) =&gt; {
                <span class="ident">_Unwind_SetGR</span>(
                    <span class="ident">unwind_ctx</span>,
                    <span class="ident">Arch::UNWIND_DATA_REG</span>.<span class="number">0</span> .<span class="number">0</span> <span class="kw">as</span> <span class="kw">_</span>,
                    <span class="ident">exception</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span> <span class="kw">as</span> <span class="ident">usize</span>,
                );
                <span class="ident">_Unwind_SetGR</span>(<span class="ident">unwind_ctx</span>, <span class="ident">Arch::UNWIND_DATA_REG</span>.<span class="number">1</span> .<span class="number">0</span> <span class="kw">as</span> <span class="kw">_</span>, <span class="number">0</span>);
                <span class="ident">_Unwind_SetIP</span>(<span class="ident">unwind_ctx</span>, <span class="ident">lpad</span>);
                <span class="ident">UnwindReasonCode::INSTALL_CONTEXT</span>
            }
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="unwinding" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>